'! 
'! Aspect Technologies 2k                                         03/14/2005
'! AT2k Holiday v1.6.0                                            File 1 of 1
'! etaX Tested []
'!
'! This script only supports ANSI or higher graphics - NO ASCII. All versions
'! of VBBS/VADV should work, but has not been tested.
'!
'! Formulas were taken from http://www.smart.net/~mmontes/ushols.html
'! The Easter formula was taken from http://aa.usno.navy.mil/faq/docs/easter.html
'! Default ASCII and ANSI screens were borrowed from the HoliBBS v4.3 package (no rights are claimed)
'!
'! Refer to the program documentation for installation procedures.
'! Filename: HOLIDAY.DOC
'!
'! AT2k Holiday v1.6      Copyright (c) 2005
'! VADV                   Copyright (c) 1991-1996  (by Roland De Graaf)
'! All Rights Reserved
'!
'!  Warranty and Liability 
'!
'! AT2k Holiday v1.6 - Holiday announcement script for VADV
'! Copyright (C) 2005 Steve Winn
'!
'! Please refer to the file LICENSE.TXT for information about warranty,
'! liability and licensing.
'!
'!  History 
'!
'! Version 1.0   - First public release.
'!  02/16/2002   - Displays a menu on configured holidays and dates. Includes
'!                 SysOp configuration utility to add new dates.
'! Version 1.1   - Made some enhancements to the SysOp configuration utility.
'!  03/26/2002     The SysOp Prompt can now be disabled. Fixed a few
'!                 formatting issues.
'! Version 1.2   - Fixed a division problem in the DOW routine which would
'!  04/03/2002     cause major problems.
'!
'! Version 1.3   - Fixed the friday the 13th bug. Also fixed a problem if the
'!  05/13/2002     config file could not be found (which causes a lockup).
'!
'! Version 1.4   - Fixed a bug when calcuating the last Sunday of a month.
'!  10/27/2002
'!
'! Version 1.5   - Fixed a problem calculating the last date of a month.
'!  05/24/2004     Fixed a problem when calculating leap year.
'!
'! Version 1.6   - It will display a happy birthday message to the user if
'!  03/14/2005     it's the user's birthday.
'!
'! 

' Note: Fixed Variables are A0, B0, C0, D0, Y0, Z0, Z1, Z2
'       Returned Variables are E0, I0, J0, J1
'       Sent Variables are O0, O1, O2

  CLEAR
  SUSPENDPAGEBREAK

  ACTION "[ASPECT]  AT2k Holiday"

' Set the variable for the buffer file (B0).
  LET B0 = "B" % !12 % ".TMP"

' Set the default value for the SysOp configuration prompt (C0).
  LET C0 = "ON"

' The variables below will determine the current day of week.
' Put the date into a variable (A0) (format is mm-dd-yyyy)
  LET A0 = !14

' Get the current month and put into variable (M0).
  LEFT M0, A0, 2

' Get the current day and put into variable (D0).
  MID D0, A0, 4, 2

' Get the current year and put into variable (Y0).
  MID Y0, A0, 7, 4

' Determine the user's display (ASCII or ANSI) and put that into a variable (Z2).
  LET Z2 = ".ANS"
  IFVAL !53 <> 0 GOTO Config_File
  LET Z2 = ".ASC"


Config_File:
' Find and set the configuration file variable (Z0)
' Z1 becomes the AT2k Holiday directory containing menu files.
  LET Z0 = !25 % "HOLIDAY\"
  LET Z1 = !25 % "HOLIDAY\HOLIDAY.CFG"
  CHECKFILE H0, Z1
  IFVAL H0 > 1 GOTO Begin
  LET Z0 = !25
  LET Z1 = !25 % "HOLIDAY.CFG"
  CHECKFILE H0, Z1
  IFVAL H0 > 1 GOTO Begin
  IFVAL !54 < 255 GOTO Exit_Script
  CLS
  LOC 2, 1
  ? "6ERROR! U 6AT2k Holiday Configuration file cannot be found!"
  DELAY 3
  GOTO Exit_Script


' -- BEGIN PROGRAM --
Begin:
' Display the program info (hidden to users).
  CLS
  LOC 1, 1
  ? "0[AT2k Holiday v1.6.0 (03/14/2005)"
  ? "0[(c) 2005 Aspect Technologies"
  CLS

' Check to see if it is the user's birthday.
  IFVAL !87 <> M0 GOTO Birthday_End
  IFVAL !88 <> D0 GOTO Birthday_End
  LET O0 = "BDAY"
  LET O1 = Z0 % O0 % Z2
  CHECKFILE H0, O1
  IFVAL H0 = 0 GOTO Birthday_End
  GOTO Display_Menu


Birthday_End:
' Open the configuration file.
  OPEN Z1, "I"


Loop:
' The Loop will check the config file for any dates matching today's date.
' Read in the line.
  READ L0
' If End Of File, then end the loop.
  IF L0 = "!EOF!" GOTO End_Loop
' If a blank line or commented line, loop again.
  IF L0 = "" GOTO Loop
  IF L0 = " " GOTO Loop
  LEFT L1, L0, 1
  IF L1 = ";" GOTO Loop
  IF L1 = "*" GOTO Get_SysOp_Config
' Determine if the config file line is the same month as the current month.
' L1 is the month.
' L2 is the day.
' L3 is the type.
' L4 is the filename.
  LEFT L1, L0, 2
  IFVAL L1 <> M0 GOTO Loop
  MID L2, L0, 4, 2
  MID L3, L0, 7, 2
  MID L4, L0, 10
' Reset the variables.
  LET M1 = M0
  LET D1 = D0
  LET Y1 = Y0
  IF L3 = "FI" GOTO Loop_Fixed
  IF L3 = "EA" GOTO Loop_Easter
' Determine the type of floating date.
' L5 is the relation.
' L6 is the day of the week.
  LEFT L5, L3, 1
  MID L6, L3, 2
' Determine if the float is a last of the month type.
  IF L5 = "L" GOTO Loop_LastDay
' Floating date is a first/second/third type.
' Set the variables.
  LET O0 = L5
  LET O1 = L6
  LET O2 = M0
' Call the OD routine. I0 is returned.
  GOSUB OD
' Determine if the floating date is todays date.
  IFVAL I0 <> D0 GOTO Loop
' Close the configuration file before proceeding since the dates match.
  CLOSE
  LET O0 = L4
  GOTO Display_Menu


Loop_LastDay:
' Floating date is a last type.
' Set the variables.
  LET O1 = L6
  LET O2 = M0
' Call the LD routine. I0 is returned.
  GOSUB LD
' Determine if the floating date is todays date.
  IFVAL I0 <> D0 GOTO Loop
' Close the configuration file before proceeding since the dates match.
  CLOSE
  LET O0 = L4
  GOTO Display_Menu


Loop_Fixed:
' Determine if the fixed date is todays date.
  IFVAL L2 <> D0 GOTO Loop
' Close the configuration file before proceeding since the dates match.
  CLOSE
  LET O0 = L4
  GOTO Display_Menu


Loop_Easter:
' Determine if today is Easter.
' Call the Easter routine. J0 and J1 is returned.
  GOSUB Easter
  IFVAL J0 <> M0 GOTO Loop
  IFVAL J1 <> D0 GOTO Loop
' Close the configuration file before proceeding since the dates match.
  CLOSE
  LET O0 = L4
  GOTO Display_Menu


End_Loop:
' Close the configuration file.
  CLOSE

' No dates were found to be valid, so one last check to see if it happens
' to be Friday the 13th :)
  LET D1 = D0
  LET M1 = M0
  LET Y1 = Y0
' Call the DOW routine. E0 is returned.
  GOSUB DOW
  IFVAL E0 <> 5 GOTO SysOp_Wait
  IFVAL D0 <> 13 GOTO SysOp_Wait
  LET O0 = "FR13"
  GOTO Display_Menu


SysOp_Wait:
' Determine if users are NOT suppose to be here :)
  IFVAL !54 < 255 GOTO Exit_Script
  IF C0 = "OFF" GOTO Exit_Script
' Display message to SysOp to enter config utility.
  LET G0 = 5
  LOC 2, 1
  ? "UAT2k Holiday - SysOp Option"
  ? "0["
  ?
  ? "9Press 2C 9within 15 9seconds to enter configuration menu."
  ? "9Press any other key to continue, or wait."
  ? "0[Note: This is not displayed to your users."
  LOC 5, 17


SysOp_Wait_Loop:
  LET G0 = G0 - 1
  DELAY 1
  RH H0
  IF H0 = "C" GOTO SysOp_Configure
  IFVAL G0 = 0 GOTO Exit_Script
  LOC 5, 16
  ? "1" % G0 % "";
  IF H0 = "" GOTO SysOp_Wait_Loop
  GOTO Exit_Script


Display_Menu:
' Display the menu, pause and then exit.
  LET O0 = O0 % Z2
  LET O1 = Z0 % O0
  CHECKFILE H0, O1
  IFVAL H0 = 0 GOTO Exit_Script
  CLS
  LOC 1, 1
  EF O1
  LOC 24, 1
  IFVAL !54 = 255 GOTO SysOp_Prompt
  PAUSE "1AT2k Holiday! U 9Press any key to continue. . ."
  CLS
  GOTO Exit_Script


SysOp_Prompt:
' Display SysOp prompt if the security level is 255.
  RC H0, "1AT2k Holiday! U [1CU]9onfigure U 9Press any key to continue. . ."
  IF H0 = "C" GOTO SysOp_Configure
  CLS
  GOTO Exit_Script


SysOp_Configure:
' Allow SysOps to add events to the configuration file.
  CLS
  LOC 2, 1
  ? "UAT2k Holiday Configuration Screen"
  ? "0["
  ?
  ? "1This utility will allow you to add holidays and events to the program."
  ? "1Note: To delete dates, you must manually edit the HOLIDAY.CFG file."
  ?
  ? "U[11U] 9Add a Date to the Configuration File"
  ? "U[12U] 9Turn the SysOp Configuration Prompt OFF"
  ? "U[1QU] 9Quit to the BBS"
  ?
  RL H0, "Q", 2, "1Choose an Option: 5"
  IF H0 = "Q" GOTO Exit_Script
  IFVAL H0 = 2 GOTO Set_SysOp_Config_OFF
' Begin config step one
  CLS
  LOC 2, 1
  ? "UAT2k Holiday Configuration - Step 1"
  ? "0["
  ?
  ? "1The first step involves determining what type of date you would like to"
  ? "1add. There are three types of dates allowed by this program:"
  ?
  ? "U1. 2Fixed 0- A fixed date falls on the same date year after year. An"
  ? "0     example would be Groundhog's Day (Feb. 2 each year)."
  ? "U2. 2Floating 0- A floating date is based on a relationship to the month,"
  ? "0     such as the third Monday in February, which would be President's Day."
  ? "U3. 2Easter 0- This will set Easter. It is based on several different things"
  ? "0     and can be a wide range of dates. Easter is enabled by default."
  ?
  RL H0, "Q", 3, "U[1QU]9uit U 9What type of date would you like to add? 5"
  IF H0 = "Q" GOTO SysOp_Configure
  IFVAL H0 = 1 GOTO SysOp_Configure_Fixed
  IFVAL H0 = 2 GOTO SysOp_Configure_Float


SysOp_Configure_Easter:
' Add Easter to the configuration file.
' First we will scan the entire file and remove any Easter values that might
' be there already.
' Clear the buffer file.
  BUFFER CLEAR
' Open the configuration file and begin the loop.
  OPEN Z1, "I"


Sysop_Configure_Easter_Loop:
' Read a line.
  READ L0
' If at the end of the file then exit the loop.
  IF L0 = "!EOF!" GOTO Sysop_Configure_Easter_Loop_End
' Break the line down.
  MID L1, L0, 7, 2
  IF L1 = "EA" GOTO Sysop_Configure_Easter_Loop
' Add the line to the buffer since it is not an Easter entry.
  BUFFER APPEND, L0
  GOTO Sysop_Configure_Easter_Loop


Sysop_Configure_Easter_Loop_End:
  CLOSE
' Replace the old configuration file with the new one.
  LET S0 = "COPY " % B0 % " " % Z1 % " > nul."
  SHELL S0
' Clear the buffer again.
  BUFFER CLEAR
' Add the Easter entry to the configuration file.
  LET G0 = "03 00 EA EAST"
  LET H0 = "04 00 EA EAST"
  OPEN Z1, "A"
    WRITE G0
    WRITE H0
  CLOSE
  ?
  ? "2Easter has been added."
  DELAY 3
  GOTO SysOp_Configure


SysOp_Configure_Fixed:
' Begin config step two.
  CLS
  LOC 2, 1
  ? "UAT2k Holiday Configuration - Step 2"
  ? "0["
  ?
  ? "9To configure a fixed date, you will just be required to enter the month of"
  ? "9the event and the day it occurs. You will also need to know the filename"
  ? "9of the menu you would like to display."
  ?
  ? "1Enter in the MONTH of the event in numeric form. 1=Jan, 2=Feb, etc."
  RL G0, "Q", 12, "U[1QU]9uit U U[11-12U] 9Month: 5"
  IF G0 = "Q" GOTO SysOp_Configure
  IFVAL G0 > 9 GOTO templabel5
    LET G1 = "0" % G0
    LET G0 = G1
  templabel5:
  ?
  ? "1Enter in the DAY of the event in numeric form."
  RL H0, "Q", 31, "U[1QU]9uit U U[11-31U] 9Day: 5"
  IF H0 = "Q" GOTO SysOp_Configure
  IFVAL H0 > 9 GOTO templabel6
    LET H1 = "0" % H0
    LET H0 = H1
  templabel6:
  ?
  ? "1Enter the filename of the menu you would like to use. The menu must be in"
  ? "1the directory with the other menus in order for it to be displayed. Do not"
  ? "1enter the extension on the filename (instead of HALL.ANS, just put HALL).
  RS I0, "U[1QU]9uit U 9Filename: 5"
  IF I0 = "Q" GOTO SysOp_Configure
  LET x = I0
  LET y = "."
  LET I1 = !8
' Check to see if the SysOp has followed directions.
  IFVAL I1 = 0 GOTO templabel7
    LEFT I0, I0, I1
  templabel7:
  LET x = I0
  LET I0 = !5
  LET J0 = G0 % " " % H0 % " FI " % I0
  GOSUB Date_Check
  OPEN Z1, "A"
    WRITE J0
  CLOSE
  ?
  ? "2The new fixed date has been added."
  DELAY 3
  GOTO SysOp_Configure
  

SysOp_Configure_Float:
' Begin config step two.
  CLS
  LOC 2, 1
  ? "UAT2k Holiday Configuration - Step 2"
  ? "0["
  ?
  ? "9To configure a floating date, you will be required to enter the month of"
  ? "9the event and the relationship to the month. You will also need to know"
  ? "9the filename of the menu you would like to display."
  ?
  ? "1Enter in the MONTH of the event in numeric form. 1=Jan, 2=Feb, etc."
  RL G0, "Q", 12, "U[1QU]9uit U U[11-12U] 9Month: 5"
  IF G0 = "Q" GOTO SysOp_Configure
  IFVAL G0 > 9 GOTO templabel8
    LET G1 = "0" % G0
    LET G0 = G1
  templabel8:
  ?
  ? "1Enter in the day of the week the event falls. 1=Mon, 2=Tues, 3=Wed,"
  ? "14=Thurs, 5=Fri, 6=Sat, 7=Sun."
  RL H0, "Q", 7, "U[1QU]9uit U 9Day of the Week: 5"
  IF H0 = "Q" GOTO SysOp_Configure
  ?
  ? "1Enter in the relationship to the month. 1=First, 2=Second, 3=Third,"
  ? "14=Fourth, 5=Fifth, L=Last."
  RL H1, "QL", 5, "U[1QU]9uit U 9Relationship: 5"
  ?
  ? "1Enter the filename of the menu you would like to use. The menu must be in"
  ? "1the directory with the other menus in order for it to be displayed. Do not"
  ? "1enter the extension on the filename (instead of HALL.ANS, just put HALL).
  RS I0, "U[1QU]9uit U 9Filename: 5"
  IF I0 = "Q" GOTO SysOp_Configure
  LET x = I0
  LET y = "."
  LET I1 = !8
' Check to see if the SysOp has followed directions.
  IFVAL I1 = 0 GOTO templabel9
    LEFT I0, I0, I1
  templabel9:
  LET x = I0
  LET I0 = !5
  LET J0 = G0 % " 00 " % H1 % H0 % " " % I0
  GOSUB Date_Check
  OPEN Z1, "A"
    WRITE J0
  CLOSE
  ?
  ? "2The new floating date has been added."
  DELAY 3
  GOTO SysOp_Configure


Get_SysOp_Config:
' This is called if the character * is found in the configuration file. It is
' used to keep up with the configuration menu setting.
  MID L1, L0, 2
  LET C0 = L1
  GOTO Loop


Set_SysOp_Config_OFF:
' This routine will turn off the SysOp Configuration Prompt.
  CLS
  LOC 2, 1
  ? "UDisabling the SysOp Configuration Prompt"
  ? "0["
  ?
  ? "1You may disable the delayed prompt given to the SysOp with this option."
  ? "1Please note that if you do disable the prompt, then you MUST configure all"
  ? "1new dates manually by editing the HOLIDAY.CFG file. Also, to re-enable the"
  ? "1prompt, you will have to manually edit the configuration file as well!"
  ?
  LET G0 = "YN" % !13
  RR H0, G0, "9Would you like to disable the prompt? U[1Yes/No/Enter=NoU]: 5"
  IF H0 = "N" GOTO SysOp_Configure
  IF H0 = !13 GOTO SysOp_Configure
  LET J0 = "; The next line disables the SysOp Configuration Prompt. To enable it, either"
  LET J1 = "; remove the line or set the value to ON."
  LET J2 = "*OFF"
  OPEN Z1, "A"
    WRITE J0
    WRITE J1
    WRITE J2
  CLOSE
  GOTO Exit_Script    
' -- END OF PROGRAM --


Date_Check:
' This routine will scan the configuration file to see if the new entry is
' already present. If so, then it will prompt the SysOp to see if he/she wants
' to replace it or keep the existing entry.
  BUFFER CLEAR
' Set some temporary variables. H0 is the default prompt answer, and H1 keeps
' up with whether the prompt has been given or not.
  LEFT J1, J0, 8
  LET H0 = "N"
  LET H1 = 0
  OPEN Z1, "I"


Date_Check_Loop:
' The loop will scan the configuration file and look for the new entry.
  READ L0
  IF L0 = "!EOF!" GOTO Date_Check_Loop_End
  LEFT L1, L0, 8
  IF L1 <> J1 GOTO Date_Check_Loop_Next
  IFVAL H1 = 1 GOTO Date_Check_Loop_Replace
  LET H1 = 1
  ?
  ? "6An entry for this date already exists in the configuration file!"
  ? "1You may replace the entry, or abort the entry."
  RR H0, "YN", "9Do you want to replace it with the new entry? 5"


Date_Check_Loop_Replace:
' This code will check to see if the SysOp wants to replace all occurances of
' the old entry with the new.
  IF H0 = "Y" GOTO Date_Check_Loop
' If abort is chosen, then close the file, clear the buffer and return to the
' configuration screen.
  CLOSE
  BUFFER CLEAR
  GOTO Sysop_Configure


Date_Check_Loop_Next:
' Add the line to the buffer and continue the loop.
  BUFFER APPEND, L0
  GOTO Date_Check_Loop


Date_Check_Loop_End:
' Now close the file, and copy the buffer over to make the new configuration file.
  CLOSE
  LET S0 = "COPY " % B0 % " " % Z1 % " > nul."
  SHELL S0
  BUFFER CLEAR
  RETURN


DOW:
' The following code will calculate the day of week a particluar date falls.
' Uses variables D1, M1, and Y1.
' All division is integer division (\)
' a = ( 14 - month ) \ 12
' y = year - a
' m = month + 12 * a - 2
' d = ( day + y + y \ 4 - y \ 100 + y \ 400 + ( 31 * m ) \ 12 ) % 7
' Begin algorithm to determine day of the week.
  LET E0 = 14 - M1 \ 12
  LET E1 = Y1 - E0
  LET E2 = 12 * E0 + M1 - 2
  LET E3 = E1 \ 4
  LET E4 = E1 \ 100
  LET E5 = E1 \ 400
  LET E6 = 31 * E2 \ 12
  LET E0 = D1 + E1 + E3 - E4 + E5 + E6
  LET E0 = E0 # 7
' E0 is the day of the week. 1 is Monday, 2 is Tuesday, 3 is Wednesday, etc.
  RETURN


OD:
' The following code will calculate the date of the first, second, third,
' fouth and fifth occurance of a day.
' Q-th N-day: NQ = 7 * Q - 6 + ( N - DoW ( Year , Month , 1 ) ) % 7

' Put the occurence (O0) in a variable (F0)
  LET F0 = O0

' Put the day of the week (O1) in a variable (G0)
  LET G0 = O1

' Put the month (O2) in a variable (H0)
  LET H0 = O2

' Calculate the algorithm using the above day of week algorithm.
  LET D1 = 1
  LET M1 = H0
  LET Y1 = Y0
' Call the DOW routine. E0 is returned.
  GOSUB DOW
' Calculate the occurence algorithm.
  LET I1 = G0 - E0
' Call the CheckRelation routine. I1 is returned.
  GOSUB CheckRelation
  LET I0 = 7 * F0 - 6 + I1
' I0 is the date that the occurence falls.
  RETURN


LD:
' The following code will calculate the date of the last day of a month.
' You must know the total number of days in the month to calculate this.
' For February, you must determine if it is a leap year or not.
' Last N-Day : NL = ND - ( DoW ( Year , Month , ND ) - N ) % 7

' Put the day of the week (01) in a variable (G0)
  LET G0 = O1

' Put the month (O2) in a variable (H0)
  LET H0 = O2

' Put the total number of days in the month (O0) in a variable (F0)
' Call the DaysOfMonth routine. W0 and O0 is returned.
  GOSUB DaysOfMonth
  LET F0 = O0

' Calculate the algorithm using the above day of week algorithm.
  LET D1 = F0
  LET M1 = H0
  LET Y1 = Y0
' Call the DOW routine. E0 is returned.
  GOSUB DOW
' Calculate the occurence algorithm.
  LET I1 = E0 - G0
' Call the CheckRelation routine. I1 is returned.
  GOSUB CheckRelation
  LET I0 = F0 - I1
' I0 is the date the last day falls.
  RETURN


CheckRelation:
  IFVAL I1 >= 0 GOTO templabel1
    LET I1 = I1 + 7
    RETURN
  templabel1:
  LET I1 = I1 # 7
  RETURN


DaysOfMonth:
' The following code will return the total number of days in a particular
' month.
  IFVAL H0 <> 1 GOTO February
  LET W0 = "January"
  LET O0 = 31
  RETURN

February:
  IFVAL H0 <> 2 GOTO March
  LET W0 = "February"
' Determine if it is a leap year or not.
  LET L7 = Y0 # 4
  LET L8 = Y0 # 100
  LET L9 = Y0 # 400
  IFVAL L7 <> 0 GOTO templabel4
  IFVAL L8 <> 0 GOTO templabel3
  IFVAL L9 = 0 GOTO templabel3
  GOTO templabel4
  templabel3:
  LET O0 = 29
  RETURN
  templabel4:
  LET O0 = 28
  RETURN

March:
  IFVAL H0 <> 3 GOTO April
  LET W0 = "March"
  LET O0 = 31
  RETURN

April:
  IFVAL H0 <> 4 GOTO May
  LET W0 = "April"
  LET O0 = 30
  RETURN

May:
  IFVAL H0 <> 5 GOTO June
  LET W0 = "May"
  LET O0 = 31
  RETURN

June:
  IFVAL H0 <> 6 GOTO July
  LET W0 = "June"
  LET O0 = 30
  RETURN

July:
  IFVAL H0 <> 7 GOTO August
  LET W0 = "July"
  LET O0 = 31
  RETURN

August:
  IFVAL H0 <> 8 GOTO September
  LET W0 = "August"
  LET O0 = 31
  RETURN

September:
  IFVAL H0 <> 9 GOTO October
  LET W0 = "September"
  LET O0 = 30
  RETURN

October:
  IFVAL H0 <> 10 GOTO November
  LET W0 = "October"
  LET O0 = 31
  RETURN

November:
  IFVAL H0 <> 11 GOTO December
  LET W0 = "November"
  LET O0 = 30
  RETURN

December:
  LET W0 = "December"
  LET O0 = 31
  RETURN


DaysOfWeek:
' The following code will return the text value of the day of the week.
  IFVAL E0 <> 1 GOTO Tuesday
  LET W1 = "Monday"
  RETURN

Tuesday:
  IFVAL E0 <> 2 GOTO Wednesday
  LET W1 = "Tuesday"
  RETURN

Wednesday:
  IFVAL E0 <> 3 GOTO Thursday
  LET W1 = "Wednesday"
  RETURN

Thursday:
  IFVAL E0 <> 4 GOTO Friday
  LET W1 = "Thursday"
  RETURN

Friday:
  IFVAL E0 <> 5 GOTO Saturday
  LET W1 = "Friday"
  RETURN

Saturday:
  IFVAL E0 <> 6 GOTO Sunday
  LET W1 = "Saturday"
  RETURN

Sunday:
  LET W1 = "Sunday"
  RETURN


Easter:
' The following code will determine Easter's date for the current year.
' All division is integer division (\)
' c = y \ 100
' n = y - 19 * ( y \ 19 )
' k = ( c - 17 ) \ 25
' i = c - c \ 4 - ( c - k ) \ 3 + 19 * n + 15
' i = i - 30 * ( i \ 30 )
' i = i - ( i \ 28 ) * ( 1 - ( i \ 28 ) * ( 29 \ ( i + 1 ) )
'     * ( ( 21 - n ) \ 11 ) )
' j = y + y \ 4 + i + 2 - c + c \ 4
' j = j - 7 * ( j \ 7 )
' l = i - j
' m = 3 + ( l + 40 ) \ 44
' d = l + 28 - 31 * ( m \ 4 )


' Calculate the algorithm and find the month and date.
  LET I0 = Y0 \ 100
  LET I1 = Y0 \ 19 * -19 + Y0
  LET I2 = I0 - 17 \ 25
    LET I4 = I0 \ 4
    LET I5 = I0 - I2 \ 3
    LET I6 = I0 - I4 - I5
  LET I3 = 19 * I1 + 15 + I6
  LET I4 = I3 \ 30 * -30 + I3
    LET I6 = I4 \ 28
    LET I7 = I4 + 1
    LET I8 = 29 \ I7
    LET I9 = 21 - I1 \ 11
    LET J0 = I6 * I8 * I9
    LET J1 = 1 - J0 * I6
  LET I5 = I4 - J1
    LET I7 = Y0 \ 4
    LET I8 = I0 \ 4
  LET I6 = Y0 + I7 + I5 + 2 - I0 + I8
  LET I7 = I6 \ 7 * -7 + I6
  LET I8 = I5 - I7
  LET J0 = I8 + 40 \ 44 + 3
' J0 is the month of Easter
  LET J1 = J0 \ 4 * -31 + 28 + I8
' J1 is the day of Easter
  RETURN


Exit_Script:
  RESUMEPAGEBREAK
  NEWPAGE
  CLS
